## libical 1.0

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the libical project.
#
# Pass the following variables to cmake to control the build:
# (See doc/UsingLibical.txt for more information)
#
# -DICAL_ERRORS_ARE_FATAL=[true|false]
#  Set to make icalerror_* calls abort instead of internally signaling an error
#  Default=false
#
# -DNO_WARN_DEPRECATED=[true|false]
#  Set if you DO NOT WANT to see deprecated messages.
#  Default=true
#
# -DICAL_ALLOW_EMPTY_PROPERTIES=[true|false]
#  Set to prevent empty properties from being replaced with X-LIC-ERROR properties.
#  Default=false
#
# -DICAL_UNIX_NEWLINE=[true|false]
#  Set to terminate each line with the RFC2445 specified line terminator "\\n";
#  else it will terminate lines with "\\n\\r"
#  Default=true
#
# -DUSE_BUILTIN_TZDATA=[true|false]
#  Set to build using our own timezone data.
#  Default=false (use the system timezone data)
#
# -DSTATIC_LIBRARY=[true|false]
#  Set to build static libraries only.
#  Default=false (build shared and static libs)
#
# -DGOBJECT_INTROSPECTION=[true|false]
#  Set to build GObject introspection "typelib" files
#  Requires GObject Introspection development package v0.6.7 or higher
#  Default=false (do not generate the introspection files)
#
# -DUSE_32BIT_TIME_T=[true|false]
#  Set to build using a 32bit time_t (ignored unless building with MSVC on Windows)
#  Default=false (use the default size of time_t)
#

project(libical)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0005 OLD)
endif(COMMAND cmake_policy)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

enable_testing()

if(WINCE)
  find_package(Wcecompat REQUIRED)
  include_directories(${WCECOMPAT_INCLUDE_DIR})
  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${WCECOMPAT_INCLUDE_DIR})
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${WCECOMPAT_LIBRARIES})
endif(WINCE)

set(LIBICAL_LIB_MAJOR_VERSION "1")
set(LIBICAL_LIB_MINOR_VERSION "0")
set(LIBICAL_LIB_PATCH_VERSION "0")
set(LIBICAL_LIB_VERSION_STRING
  "${LIBICAL_LIB_MAJOR_VERSION}.${LIBICAL_LIB_MINOR_VERSION}.${LIBICAL_LIB_PATCH_VERSION}"
)

set(PROJECT_VERSION "${LIBICAL_LIB_MAJOR_VERSION}.${LIBICAL_LIB_MINOR_VERSION}")
set(PROJECT_URL "http://freeassociation.sf.net/")

if(STATIC_LIBRARY)
  set(LIBICAL_STATIC 1)
  add_definitions(-DLIBICAL_STATIC)
  set(LIBRARY_TYPE STATIC)
else(STATIC_LIBRARY)
  set(LIBRARY_TYPE SHARED)
endif(STATIC_LIBRARY)

# must have Perl to create the derived stuff
find_package(Perl REQUIRED)

# MSVC specific definitions
if(WIN32)
  if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DYY_NO_UNISTD_H)
    if(USE_32BIT_TIME_T)
      add_definitions(-D_USE_32BIT_TIME_T)
    endif(USE_32BIT_TIME_T)
  endif(MSVC)
  add_definitions(-DBIG_ENDIAN=0 -DLITTLE_ENDIAN=1 -DBYTE_ORDER=BIG_ENDIAN)
endif(WIN32)

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Library directory name" FORCE)
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Include directory name" FORCE)
set(SHARE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share" CACHE STRING "Share directory name" FORCE)

# set the output paths
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
if(WIN32)
  set(LIBRARY_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH})
  set(LIB_INSTALL_DIR lib)
  set(BIN_INSTALL_DIR bin)
else(WIN32)
  set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)
endif(WIN32)

if(APPLE)
  set(CMAKE_INSTALL_NAME_DIR ${LIB_DESTINATION})
endif(APPLE)

if(NOT DEFINED ICAL_ERRORS_ARE_FATAL)
  set(ICAL_ERRORS_ARE_FATAL 0)
else(NOT DEFINED ICAL_ERRORS_ARE_FATAL)
  if(ICAL_ERRORS_ARE_FATAL)
    set(ICAL_ERRORS_ARE_FATAL 1)
  else(ICAL_ERRORS_ARE_FATAL)
    set(ICAL_ERRORS_ARE_FATAL 0)
  endif(ICAL_ERRORS_ARE_FATAL)
endif(NOT DEFINED ICAL_ERRORS_ARE_FATAL)

if(NOT DEFINED ICAL_UNIX_NEWLINE)
  set(ICAL_UNIX_NEWLINE 1)
else(NOT DEFINED ICAL_UNIX_NEWLINE)
  if(ICAL_UNIX_NEWLINE)
    set(ICAL_UNIX_NEWLINE 1)
  else(ICAL_UNIX_NEWLINE)
    set(ICAL_UNIX_NEWLINE 0)
  endif(ICAL_UNIX_NEWLINE)
endif(NOT DEFINED ICAL_UNIX_NEWLINE)

if(NOT DEFINED ICAL_ALLOW_EMPTY_PROPERTIES)
  set(ICAL_ALLOW_EMPTY_PROPERTIES 0)
else(NOT DEFINED ICAL_ALLOW_EMPTY_PROPERTIES)
  if(ICAL_ALLOW_EMPTY_PROPERTIES)
    set(ICAL_ALLOW_EMPTY_PROPERTIES 1)
  else(ICAL_ALLOW_EMPTY_PROPERTIES)
    set(ICAL_ALLOW_EMPTY_PROPERTIES 0)
  endif(ICAL_ALLOW_EMPTY_PROPERTIES)
endif(NOT DEFINED ICAL_ALLOW_EMPTY_PROPERTIES)

if(NOT DEFINED NO_WARN_DEPRECATED)
  set(NO_WARN_DEPRECATED 1)
else(NOT DEFINED NO_WARN_DEPRECATED)
  if(NO_WARN_DEPRECATED)
    set(NO_WARN_DEPRECATED 1)
  else(NO_WARN_DEPRECATED)
    set(NO_WARN_DEPRECATED 0)
  endif(NO_WARN_DEPRECATED)
endif(NOT DEFINED NO_WARN_DEPRECATED)

if(NOT DEFINED USE_BUILTIN_TZDATA)
  set(USE_BUILTIN_TZDATA 0)
else(NOT DEFINED USE_BUILTIN_TZDATA)
  if(USE_BUILTIN_TZDATA)
    set(USE_BUILTIN_TZDATA 1)
  else(USE_BUILTIN_TZDATA)
    set(USE_BUILTIN_TZDATA 0)
  endif(USE_BUILTIN_TZDATA)
endif(NOT DEFINED USE_BUILTIN_TZDATA)

include(ConfigureChecks.cmake)
add_definitions(-DHAVE_CONFIG_H)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

set(INSTALL_TARGETS_DEFAULT_ARGS
  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

if(GOBJECT_INTROSPECTION)
  set(MIN_GOBJECT_INTROSPECTION "0.6.7")
  find_package(GObjectIntrospection ${MIN_GOBJECT_INTROSPECTION})
  if(INTROSPECTION_FOUND)
    set(HAVE_INTROSPECTION TRUE)
  else(INTROSPECTION_FOUND)
    message(FATAL_ERROR "You requested to build with GObject Introspection but the necessary development package is missing or too low a version (version ${MIN_GOBJECT_INTROSPECTION} or higher is required)")
  endif(INTROSPECTION_FOUND)
endif(GOBJECT_INTROSPECTION)

################# build subdirs ########################

add_subdirectory(design-data)
add_subdirectory(doc)
add_subdirectory(scripts)
add_subdirectory(test-data)
add_subdirectory(src)
add_subdirectory(examples)
if(USE_BUILTIN_TZDATA)
  # use our zoneinfo if cmake is passed -DUSE_BUILTIN_TZDATA
  add_subdirectory(zoneinfo)
endif(USE_BUILTIN_TZDATA)

########### create and install pkg-config file #########

set(VERSION "${PROJECT_VERSION}")
set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/lib")
set(includedir "\${prefix}/include")
set(PTHREAD_LIBS "${CMAKE_THREAD_LIBS_INIT}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libical.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libical.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libical.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

=== examples/CMakeLists.txt ===
include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src/libical ${CMAKE_BINARY_DIR}/src/libical
  ${CMAKE_SOURCE_DIR}/src/libicalss ${CMAKE_BINARY_DIR}/src/libicalss
)

########### next target ###############

set(doesnothing_SRCS
  access_components.c
  access_properties_and_parameters.c
  errors.c
  main.c
  parse_text.c
)

add_executable(doesnothing ${doesnothing_SRCS})

target_link_libraries(doesnothing ical icalss icalvcal ical icalss icalvcal)

########### install files ###############

=== zoneinfo/CMakeLists.txt ===

########### install files ###############

install(FILES zones.tab DESTINATION ${SHARE_INSTALL_DIR}/libical/zoneinfo)

set(zoneinfodir
  Africa
  America
  America/North_Dakota
  America/Indiana
  America/Kentucky
  America/Argentina
  Antarctica
  Arctic
  Asia
  Atlantic
  Australia
  Europe
  Indian
  Pacific
)

foreach(_zoneinfocurrentdir ${zoneinfodir})
  file(GLOB _icsfile "${_zoneinfocurrentdir}/*.ics")
  install(
    FILES ${_icsfile}
    DESTINATION ${SHARE_INSTALL_DIR}/libical/zoneinfo/${_zoneinfocurrentdir}/
  )
endforeach(_zoneinfocurrentdir ${zoneinfodir})

=== src/java/CMakeLists.txt ===

########### next target ###############

set(ical_jni_LIB_SRCS
  jlibical_consts_cxx.h
  jlibical_utils_cxx.cpp
  jlibical_utils_cxx.h
  jniICalDurationType_cxx.cpp
  jniICalDurationType_cxx.h
  jniICalPeriodType_cxx.cpp
  jniICalPeriodType_cxx.h
  jniICalRecurrenceType_cxx.cpp
  jniICalRecurrenceType_cxx.h
  jniICalTimeType_cxx.cpp
  jniICalTimeType_cxx.h
  jniICalTriggerType_cxx.cpp
  jniICalTriggerType_cxx.h
  net_cp_jlibical_ICalParameter_cxx.cpp
  net_cp_jlibical_ICalParameter_cxx.h
  net_cp_jlibical_ICalProperty_cxx.cpp
  net_cp_jlibical_ICalProperty_cxx.h
  net_cp_jlibical_ICalValue_cxx.cpp
  net_cp_jlibical_ICalValue_cxx.h
  net_cp_jlibical_VComponent_cxx.cpp
  net_cp_jlibical_VComponent_cxx.h
)

add_library(ical_jni ${LIBRARY_TYPE} ${ical_jni_LIB_SRCS})

target_link_libraries(ical_jni ical_cxx)

set_target_properties(ical_jni PROPERTIES
  VERSION ${LIBICAL_LIB_VERSION_STRING}
  SOVERSION ${LIBICAL_LIB_MAJOR_VERSION}
)
install(TARGETS ical_jni DESTINATION lib)

########### install files ###############

install(FILES DESTINATION /include)
install(FILES libical.jar DESTINATION /share)

=== src/libical/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/icalversion.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/icalversion.h @ONLY)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/src/libical
  ${CMAKE_BINARY_DIR}/src/libical
)

if(WIN32)
  if(MSVC)
    add_definitions(-DBUILD_LIBICALDLL)
  endif(MSVC)
endif(WIN32)

configure_file(icalerror.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/icalerror.h)

set(PACKAGE_DATA_DIR "\\\"${CMAKE_INSTALL_PREFIX}/share/libical\\\"")
add_definitions(-DPACKAGE_DATA_DIR="${PACKAGE_DATA_DIR}")

set(ICALSCRIPTS ${CMAKE_SOURCE_DIR}/scripts/)

set(PROPERTYDEPS
  ${ICALSCRIPTS}/mkderivedproperties.pl
  ${CMAKE_SOURCE_DIR}/design-data/properties.csv
  ${CMAKE_SOURCE_DIR}/design-data/value-types.csv
  ${CMAKE_SOURCE_DIR}/src/libical/icalderivedproperty.h.in
  ${CMAKE_SOURCE_DIR}/src/libical/icalderivedproperty.c.in
)

add_custom_command(
  OUTPUT
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedproperty.h
  COMMAND
  ${PERL_EXECUTABLE} -I ${ICALSCRIPTS} ${ICALSCRIPTS}/mkderivedproperties.pl
    -i ${CMAKE_SOURCE_DIR}/src/libical/icalderivedproperty.h.in
    -h ${CMAKE_SOURCE_DIR}/design-data/properties.csv
    ${CMAKE_SOURCE_DIR}/design-data/value-types.csv >
    ${CMAKE_BINARY_DIR}/src/libical/icalderivedproperty.h
  DEPENDS ${PROPERTYDEPS}
)

add_custom_command(
  OUTPUT
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedproperty.c
  COMMAND
  ${PERL_EXECUTABLE} -I${ICALSCRIPTS} ${ICALSCRIPTS}/mkderivedproperties.pl
    -i ${CMAKE_SOURCE_DIR}/src/libical/icalderivedproperty.c.in
    -c ${CMAKE_SOURCE_DIR}/design-data/properties.csv
    ${CMAKE_SOURCE_DIR}/design-data/value-types.csv >
    ${CMAKE_BINARY_DIR}/src/libical/icalderivedproperty.c
    DEPENDS ${PROPERTYDEPS} ${CMAKE_BINARY_DIR}/src/libical/icalderivedproperty.h
)

set(PARAMETERDEPS
  ${ICALSCRIPTS}/mkderivedparameters.pl
  ${CMAKE_SOURCE_DIR}/design-data/parameters.csv
  ${CMAKE_SOURCE_DIR}/src/libical/icalderivedparameter.c.in
  ${CMAKE_SOURCE_DIR}/src/libical/icalderivedparameter.h.in
)

add_custom_command(
  OUTPUT
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedparameter.h
  COMMAND
  ${PERL_EXECUTABLE} -I ${ICALSCRIPTS} ${ICALSCRIPTS}/mkderivedparameters.pl
    -i ${CMAKE_SOURCE_DIR}/src/libical/icalderivedparameter.h.in
    -h ${CMAKE_SOURCE_DIR}/design-data/parameters.csv >
    ${CMAKE_BINARY_DIR}/src/libical/icalderivedparameter.h
  DEPENDS ${PARAMETERDEPS}
)

add_custom_command(
  OUTPUT
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedparameter.c
  COMMAND
  ${PERL_EXECUTABLE} -I ${ICALSCRIPTS} ${ICALSCRIPTS}/mkderivedparameters.pl
    -i ${CMAKE_SOURCE_DIR}/src/libical/icalderivedparameter.c.in
    -c ${CMAKE_SOURCE_DIR}/design-data/parameters.csv >
    ${CMAKE_BINARY_DIR}/src/libical/icalderivedparameter.c
  DEPENDS ${PARAMETERDEPS} ${CMAKE_BINARY_DIR}/src/libical/icalderivedparameter.h
)

set(RESTRICTIONDEPS
  ${ICALSCRIPTS}/mkrestrictiontable.pl
  ${CMAKE_SOURCE_DIR}/design-data/restrictions.csv
  ${CMAKE_SOURCE_DIR}/src/libical/icalrestriction.c.in
)

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/src/libical/)
add_custom_command(
  OUTPUT
  ${CMAKE_BINARY_DIR}/src/libical/icalrestriction.c
  COMMAND
  ${PERL_EXECUTABLE} -I ${ICALSCRIPTS} ${ICALSCRIPTS}/mkrestrictiontable.pl
    -i ${CMAKE_SOURCE_DIR}/src/libical/icalrestriction.c.in
    ${CMAKE_SOURCE_DIR}/design-data/restrictions.csv >
    ${CMAKE_BINARY_DIR}/src/libical/icalrestriction.c
  DEPENDS ${RESTRICTIONDEPS}
)

set(VALUEDEPS
  ${ICALSCRIPTS}mkderivedvalues.pl
  ${CMAKE_SOURCE_DIR}/design-data/value-types.csv
  ${CMAKE_SOURCE_DIR}/src/libical/icalderivedvalue.c.in
  ${CMAKE_SOURCE_DIR}/src/libical/icalderivedvalue.h.in
)

add_custom_command(
  OUTPUT
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedvalue.h
  COMMAND
  ${PERL_EXECUTABLE} -I${ICALSCRIPTS} ${ICALSCRIPTS}/mkderivedvalues.pl
    -i ${CMAKE_SOURCE_DIR}/src/libical/icalderivedvalue.h.in
    -h ${CMAKE_SOURCE_DIR}/design-data/value-types.csv >
    ${CMAKE_BINARY_DIR}/src/libical/icalderivedvalue.h
  DEPENDS ${VALUEDEPS}
)

add_custom_command(
  OUTPUT
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedvalue.c
  COMMAND
  ${PERL_EXECUTABLE} -I${ICALSCRIPTS} ${ICALSCRIPTS}/mkderivedvalues.pl
    -i ${CMAKE_SOURCE_DIR}/src/libical/icalderivedvalue.c.in
    -c ${CMAKE_SOURCE_DIR}/design-data/value-types.csv >
    ${CMAKE_BINARY_DIR}/src/libical/icalderivedvalue.c
  DEPENDS ${VALUEDEPS} ${CMAKE_BINARY_DIR}/src/libical/icalderivedvalue.h
)

if(WIN32)
  set(TOPS "\"${CMAKE_SOURCE_DIR}\"")
  set(TOPB "\"${CMAKE_BINARY_DIR}\"")
else(WIN32)
  set(TOPS "${CMAKE_SOURCE_DIR}")
  set(TOPB "${CMAKE_BINARY_DIR}")
endif(WIN32)

add_custom_command(
  OUTPUT
  ${CMAKE_BINARY_DIR}/src/libical/ical.h
  COMMAND
  ${CMAKE_COMMAND}
    -DTOPS:FILEPATH=${TOPS}
    -DTOPB:FILEPATH=${TOPB}
    -DICAL_FILE_H_FILE:FILEPATH=${CMAKE_BINARY_DIR}/src/libical/ical.h
    -P ${CMAKE_CURRENT_SOURCE_DIR}/ical_file.cmake
  DEPENDS
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedproperty.h
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedparameter.h
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedvalue.h
)

add_custom_target(ical-header DEPENDS
  ${CMAKE_BINARY_DIR}/src/libical/ical.h
)

macro(_list_prefix _outvar _listvar _prefix)
  set(${_outvar})
  foreach(_item IN LISTS ${_listvar})
    list(APPEND ${_outvar} ${_prefix}${_item})
  endforeach()
endmacro(_list_prefix)

# GObject Introspection
if(HAVE_INTROSPECTION)
  include(GObjectIntrospectionMacros)
  set(INTROSPECTION_GIRS)
  #set(INTROSPECTION_SCANNER_ARGS "--add-include-path=${CMAKE_CURRENT_SOURCE_DIR}")
  #set(INTROSPECTION_COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}")

  set(libical_0_48_gir "libical")
  set(libical_0_48_gir_VERSION "0.48")
  set(INTROSPECTION_SCANNER_ARGS ${CMAKE_BINARY_DIR}/src/libical/ical.h)
  set(libical_0_48_gir_LIBRARY "ical")
  set(libical_0_48_gir_INCLUDES GObject-2.0)
  get_directory_property(_tmp_includes ical_LIB_SRCS)
  _list_prefix(_includes _tmp_includes "-L")
  set(libical_0_48_gir_CFLAGS ${_includes})
  set(libical_0_48_gir_LIBS ical)

  list(APPEND INTROSPECTION_GIRS libical-0.48.gir)

  gir_add_introspections(INTROSPECTION_GIRS)
endif()

########### next target ###############

set(BUILT_COMBINEDHEADERS
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedparameter.h
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedproperty.h
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedvalue.h
)

set(BUILT_SOURCES
  ${BUILT_COMBINEDHEADERS}
  icalderivedparameter.c
  icalderivedproperty.c
  icalrestriction.c
  icalderivedvalue.c
)

set(ical_LIB_SRCS
  ${BUILT_SOURCES}
  icalarray.c
  icalarray.h
  icalattach.h
  icalattachimpl.h
  icalattach.c
  icalcomponent.c
  icalcomponent.h
  icalenums.c
  icalenums.h
  icalerror.c
  icalmemory.c
  icalmemory.h
  icalmime.c
  icalmime.h
  icalparameter.c
  icalparameter.h
  icalparameterimpl.h
  icalparser.c
  icalparser.h
  icalproperty.c
  icalproperty.h
  icalrecur.c
  icalrecur.h
  icalrestriction.h
  icaltime.c
  icaltime.h
  icaltz-util.c
  icaltz-util.h
  icaltimezone.c
  icaltimezone.h
  icalduration.h
  icalduration.c
  icalperiod.h
  icalperiod.c
  icaltypes.c
  icaltypes.h
  icalvalue.c
  icalvalue.h
  icalvalueimpl.h
  pvl.c
  pvl.h
  sspm.c
  sspm.h
  icallangbind.h
  icallangbind.c
  caldate.c
  astime.h
)
if(WIN32)
  if(MSVC)
    list(APPEND ical_LIB_SRCS ../ical.def)
  endif(MSVC)
endif(WIN32)

add_library(ical ${LIBRARY_TYPE} ${ical_LIB_SRCS})
add_library(ical-static STATIC ${ical_LIB_SRCS})

add_dependencies(ical ical-header)

target_link_libraries(ical ${CMAKE_THREAD_LIBS_INIT})

if(WINCE)
  target_link_libraries(ical ${WCECOMPAT_LIBRARIES})
endif(WINCE)

if(MSVC)
  set_target_properties(ical PROPERTIES OUTPUT_NAME "libical")
  set_target_properties(ical-static PROPERTIES OUTPUT_NAME "libical-static")
else(MSVC)
  set_target_properties(ical-static PROPERTIES OUTPUT_NAME "ical")
endif(MSVC)
set_target_properties(ical PROPERTIES
  VERSION ${LIBICAL_LIB_VERSION_STRING}
  SOVERSION ${LIBICAL_LIB_MAJOR_VERSION}
)
set_target_properties(ical PROPERTIES CLEAN_DIRECT_OUTPUT 1)
set_target_properties(ical-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)

install(TARGETS ical ical-static ${INSTALL_TARGETS_DEFAULT_ARGS})

########### install files ###############

install(FILES ${CMAKE_SOURCE_DIR}/src/ical.h DESTINATION ${INCLUDE_INSTALL_DIR})

install(FILES
  ${CMAKE_BINARY_DIR}/src/libical/ical.h
  icalarray.h
  icalattach.h
  icalcomponent.h
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedparameter.h
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedproperty.h
  ${CMAKE_BINARY_DIR}/src/libical/icalderivedvalue.h
  icalduration.h
  icalenums.h
  ${CMAKE_BINARY_DIR}/src/libical/icalerror.h
  icallangbind.h
  icalmemory.h
  icalmime.h
  icalparameter.h
  icalparser.h
  icalperiod.h
  icalproperty.h
  icalrecur.h
  icalrestriction.h
  icaltime.h
  icaltz-util.h
  icaltimezone.h
  icaltypes.h
  icalvalue.h
  pvl.h
  sspm.h
  DESTINATION
  ${INCLUDE_INSTALL_DIR}/libical
)

=== src/test/CMakeLists.txt ===
include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_BINARY_DIR}/src
)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

set(TEST_DATADIR "\\\"${CMAKE_SOURCE_DIR}/test-data\\\"")
add_definitions(-DTEST_DATADIR=${TEST_DATADIR})

########### next target ###############

set(copycluster_SRCS copycluster.c)

add_executable(copycluster ${copycluster_SRCS})

target_link_libraries(copycluster ical icalss)

########### next target ###############

set(regression_SRCS
  regression.c
  regression.h
  regression-component.c
  regression-classify.c
  regression-utils.c
  regression-recur.c
  regression-storage.c
)

add_executable(regression ${regression_SRCS})

target_link_libraries(regression ical icalss icalvcal)

add_test(NAME regression WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/bin COMMAND regression)

########### next target ###############

set(parser_SRCS icaltestparser.c)

add_executable(parser ${parser_SRCS})

target_link_libraries(parser ical icalss)

########### next target ###############

if(NOT WIN32)
  set(STOW_SRCS stow.c)

  add_executable(stow ${STOW_SRCS})

  target_link_libraries(stow ical icalss)
endif(NOT WIN32)

########### next target ###############

set(recur_SRCS recur.c)

add_executable(recur ${recur_SRCS})

target_link_libraries(recur ical icalss)

########### next target ###############

if(HAVE_UNISTD_H)
  set(testmime_SRCS testmime.c)

  add_executable(testmime ${testmime_SRCS})

  target_link_libraries(testmime ical icalss)
endif(HAVE_UNISTD_H)

########### next target ###############

set(testvcal_SRCS testvcal.c)

add_executable(testvcal ${testvcal_SRCS})

target_link_libraries(testvcal ical icalss icalvcal)

########### next target ###############

set(process_SRCS process.c)

add_executable(process ${process_SRCS})

target_link_libraries(process ical icalss)

########### next target ###############

if(NOT WIN32)
  set(timezones_SRCS timezones.c)

  add_executable(timezones ${timezones_SRCS})

  target_link_libraries(timezones ical icalss)

  add_test(NAME timezones WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/bin COMMAND timezones)
endif(NOT WIN32)

########### install files ###############

=== debian/changelog ===
libical (1.0-0ubuntu1) saucy; urgency=low

  * New upstream release
  * Remove patched now upstream
   - 0001_convert_float_to_strings_with_snprintf_sfbug3493034.patch
   - fix_arm_ftbfs.patch
   - fix_ftbfs_dependencies.patch

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 11 Jun 2013 15:29:40 +0100

=== debian/control ===
Source: libical
Section: libs
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Fathi Boudra <fabo@debian.org>
Build-Depends: debhelper (>= 9), cmake, tzdata
Standards-Version: 3.9.3
Homepage: http://freeassociation.sourceforge.net

Package: libical-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libical1 (= ${binary:Version})
Description: iCalendar library implementation in C (development)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.

Package: libical1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tzdata
Description: iCalendar library implementation in C (runtime)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.
 .
 This package contains the files necessary for running applications that use
 the libical library.

Package: libical-dbg
Priority: extra
Architecture: any
Section: debug
Depends: libical1 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for libical
 This package contains the debugging symbols associated with libical.
 .
 They will automatically be used by gdb for debugging libical related issues.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake --parallel --list-missing --dbg-package=libical-dbg

## libical 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,15 +18,21 @@
 # -DICAL_UNIX_NEWLINE=[true|false]
 #  Set to terminate each line with the RFC2445 specified line terminator "\\n";
 #  else it will terminate lines with "\\n\\r"
-#  Default=true
+#  Default=true (on non-Windows systems; else false)
 #
 # -DUSE_BUILTIN_TZDATA=[true|false]
 #  Set to build using our own timezone data.
-#  Default=false (use the system timezone data)
-#
-# -DSTATIC_LIBRARY=[true|false]
+#  Default=false (use the system timezone data on non-Windows systems)
+#  ALWAYS true on Windows systems
+#
+# -DSTATIC_ONLY=[true|false]
 #  Set to build static libraries only.
 #  Default=false (build shared and static libs)
+#
+# -DSHARED_ONLY=[true|false]
+#  Set to build shared (dynamic) libraries only.
+#  Default=false (build shared and static libs)
+#  Takes precedence over STATIC_ONLY
 #
 # -DGOBJECT_INTROSPECTION=[true|false]
 #  Set to build GObject introspection "typelib" files
@@ -38,13 +44,14 @@
 #  Default=false (use the default size of time_t)
 #
 
-project(libical)
-
-cmake_minimum_required(VERSION 2.4)
+cmake_minimum_required(VERSION 2.8.9)
+
+project(libical C CXX)
+
 if(COMMAND cmake_policy)
   cmake_policy(SET CMP0003 NEW)
   cmake_policy(SET CMP0005 OLD)
-endif(COMMAND cmake_policy)
+endif()
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 
@@ -55,25 +62,34 @@
   include_directories(${WCECOMPAT_INCLUDE_DIR})
   set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${WCECOMPAT_INCLUDE_DIR})
   set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${WCECOMPAT_LIBRARIES})
-endif(WINCE)
+endif()
 
 set(LIBICAL_LIB_MAJOR_VERSION "1")
 set(LIBICAL_LIB_MINOR_VERSION "0")
-set(LIBICAL_LIB_PATCH_VERSION "0")
+set(LIBICAL_LIB_PATCH_VERSION "1")
 set(LIBICAL_LIB_VERSION_STRING
   "${LIBICAL_LIB_MAJOR_VERSION}.${LIBICAL_LIB_MINOR_VERSION}.${LIBICAL_LIB_PATCH_VERSION}"
 )
 
 set(PROJECT_VERSION "${LIBICAL_LIB_MAJOR_VERSION}.${LIBICAL_LIB_MINOR_VERSION}")
-set(PROJECT_URL "http://freeassociation.sf.net/")
-
-if(STATIC_LIBRARY)
+set(PROJECT_URL "http://libical.github.io/libical/")
+
+# library build types
+set(LIBICAL_STATIC 0)
+set(LIBRARY_TYPE SHARED)
+
+if(STATIC_ONLY)
   set(LIBICAL_STATIC 1)
   add_definitions(-DLIBICAL_STATIC)
   set(LIBRARY_TYPE STATIC)
-else(STATIC_LIBRARY)
+endif()
+
+if(SHARED_ONLY)
+  set(STATIC_ONLY False)
+  set(LIBICAL_STATIC 0)
+  remove_definitions(-DLIBICAL_STATIC)
   set(LIBRARY_TYPE SHARED)
-endif(STATIC_LIBRARY)
+endif()
 
 # must have Perl to create the derived stuff
 find_package(Perl REQUIRED)
@@ -84,10 +100,10 @@
     add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DYY_NO_UNISTD_H)
     if(USE_32BIT_TIME_T)
       add_definitions(-D_USE_32BIT_TIME_T)
-    endif(USE_32BIT_TIME_T)
-  endif(MSVC)
+    endif()
+  endif()
   add_definitions(-DBIG_ENDIAN=0 -DLITTLE_ENDIAN=1 -DBYTE_ORDER=BIG_ENDIAN)
-endif(WIN32)
+endif()
 
 set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
 set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Library directory name" FORCE)
@@ -100,63 +116,72 @@
   set(LIBRARY_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH})
   set(LIB_INSTALL_DIR lib)
   set(BIN_INSTALL_DIR bin)
-else(WIN32)
+else()
   set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)
-endif(WIN32)
+endif()
 
 if(APPLE)
   set(CMAKE_INSTALL_NAME_DIR ${LIB_DESTINATION})
-endif(APPLE)
+endif()
 
 if(NOT DEFINED ICAL_ERRORS_ARE_FATAL)
   set(ICAL_ERRORS_ARE_FATAL 0)
-else(NOT DEFINED ICAL_ERRORS_ARE_FATAL)
+else()
   if(ICAL_ERRORS_ARE_FATAL)
     set(ICAL_ERRORS_ARE_FATAL 1)
-  else(ICAL_ERRORS_ARE_FATAL)
+  else()
     set(ICAL_ERRORS_ARE_FATAL 0)
-  endif(ICAL_ERRORS_ARE_FATAL)
-endif(NOT DEFINED ICAL_ERRORS_ARE_FATAL)
+  endif()
+endif()
 
 if(NOT DEFINED ICAL_UNIX_NEWLINE)
-  set(ICAL_UNIX_NEWLINE 1)
-else(NOT DEFINED ICAL_UNIX_NEWLINE)
+  if(WIN32 OR WINCE)
+    set(ICAL_UNIX_NEWLINE 0)
+  else()
+    set(ICAL_UNIX_NEWLINE 1)
+  endif()
+else()
   if(ICAL_UNIX_NEWLINE)
     set(ICAL_UNIX_NEWLINE 1)
-  else(ICAL_UNIX_NEWLINE)
+  else()
     set(ICAL_UNIX_NEWLINE 0)
-  endif(ICAL_UNIX_NEWLINE)
-endif(NOT DEFINED ICAL_UNIX_NEWLINE)
+  endif()
+endif()
 
 if(NOT DEFINED ICAL_ALLOW_EMPTY_PROPERTIES)
   set(ICAL_ALLOW_EMPTY_PROPERTIES 0)
-else(NOT DEFINED ICAL_ALLOW_EMPTY_PROPERTIES)
+else()
   if(ICAL_ALLOW_EMPTY_PROPERTIES)
     set(ICAL_ALLOW_EMPTY_PROPERTIES 1)
-  else(ICAL_ALLOW_EMPTY_PROPERTIES)
+  else()
     set(ICAL_ALLOW_EMPTY_PROPERTIES 0)
-  endif(ICAL_ALLOW_EMPTY_PROPERTIES)
-endif(NOT DEFINED ICAL_ALLOW_EMPTY_PROPERTIES)
+  endif()
+endif()
 
 if(NOT DEFINED NO_WARN_DEPRECATED)
   set(NO_WARN_DEPRECATED 1)
-else(NOT DEFINED NO_WARN_DEPRECATED)
+else()
   if(NO_WARN_DEPRECATED)
     set(NO_WARN_DEPRECATED 1)
-  else(NO_WARN_DEPRECATED)
+  else()
     set(NO_WARN_DEPRECATED 0)
-  endif(NO_WARN_DEPRECATED)
-endif(NOT DEFINED NO_WARN_DEPRECATED)
+  endif()
+endif()
 
 if(NOT DEFINED USE_BUILTIN_TZDATA)
   set(USE_BUILTIN_TZDATA 0)
-else(NOT DEFINED USE_BUILTIN_TZDATA)
+else()
   if(USE_BUILTIN_TZDATA)
     set(USE_BUILTIN_TZDATA 1)
-  else(USE_BUILTIN_TZDATA)
+  else()
     set(USE_BUILTIN_TZDATA 0)
-  endif(USE_BUILTIN_TZDATA)
-endif(NOT DEFINED USE_BUILTIN_TZDATA)
+  endif()
+endif()
+#Always use builtin tzdata on Windows systems.
+if(WIN32 OR WINCE)
+  message(STATUS "Currently unable to use system tzdata on Windows. Falling back to builtin tzdata")
+  set(USE_BUILTIN_TZDATA 1)
+endif()
 
 include(ConfigureChecks.cmake)
 add_definitions(-DHAVE_CONFIG_H)
@@ -173,10 +198,47 @@
   find_package(GObjectIntrospection ${MIN_GOBJECT_INTROSPECTION})
   if(INTROSPECTION_FOUND)
     set(HAVE_INTROSPECTION TRUE)
-  else(INTROSPECTION_FOUND)
+  else()
     message(FATAL_ERROR "You requested to build with GObject Introspection but the necessary development package is missing or too low a version (version ${MIN_GOBJECT_INTROSPECTION} or higher is required)")
-  endif(INTROSPECTION_FOUND)
-endif(GOBJECT_INTROSPECTION)
+  endif()
+endif()
+
+#
+# Compiler settings
+#
+if(CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
+  include(CheckCCompilerFlag)
+  check_c_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
+  check_c_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
+  check_c_compiler_flag(-Wsizeof-pointer-memaccess HAVE_GCC_POINTER_MEMACCESS)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-deprecated -Wall -Wextra -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Werror=return-type")
+  if(HAVE_GCC_UNUSED_BUT_SET)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused-but-set-variable")
+  endif()
+  if(HAVE_GCC_LOGICAL_OP)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wlogical-op")
+  endif()
+  if(HAVE_GCC_POINTER_MEMACCESS)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wsizeof-pointer-memaccess")
+  endif()
+endif()
+
+if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+  include(CheckCXXCompilerFlag)
+  check_cxx_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
+  check_cxx_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
+  check_cxx_compiler_flag(-Wsizeof-pointer-memaccess HAVE_GCC_POINTER_MEMACCESS)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wall -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Werror=return-type")
+  if(HAVE_GCC_UNUSED_BUT_SET)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-but-set-variable")
+  endif()
+  if(HAVE_GCC_LOGICAL_OP)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
+  endif()
+  if(HAVE_GCC_POINTER_MEMACCESS)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsizeof-pointer-memaccess")
+  endif()
+endif()
 
 ################# build subdirs ########################
 
@@ -189,7 +251,7 @@
 if(USE_BUILTIN_TZDATA)
   # use our zoneinfo if cmake is passed -DUSE_BUILTIN_TZDATA
   add_subdirectory(zoneinfo)
-endif(USE_BUILTIN_TZDATA)
+endif()
 
 ########### create and install pkg-config file #########
 
@@ -202,3 +264,30 @@
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libical.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libical.pc @ONLY)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libical.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
+
+########### Create and install the CMake Config files ##########
+include(CMakePackageConfigHelpers)
+
+configure_package_config_file(
+  LibIcalConfig.cmake.in ${libical_BINARY_DIR}/LibIcalConfig.cmake
+  INSTALL_DESTINATION ${LIB_INSTALL_DIR}/cmake/LibIcal
+  PATH_VARS LIB_INSTALL_DIR INCLUDE_INSTALL_DIR
+)
+
+# Create a version file
+write_basic_package_version_file(
+  ${libical_BINARY_DIR}/LibIcalConfigVersion.cmake
+  VERSION ${LIBICAL_LIB_VERSION_STRING}
+  COMPATIBILITY SameMajorVersion
+)
+
+install(
+  FILES ${libical_BINARY_DIR}/LibIcalConfigVersion.cmake ${libical_BINARY_DIR}/LibIcalConfig.cmake
+  DESTINATION ${LIB_INSTALL_DIR}/cmake/LibIcal
+)
+
+install(
+  EXPORT icalTargets
+  DESTINATION ${LIB_INSTALL_DIR}/cmake/LibIcal
+  FILE LibIcalTargets.cmake
+)

=== src/CMakeLists.txt ===
add_subdirectory(libical)
add_subdirectory(libicalss)
add_subdirectory(libicalvcal)
add_subdirectory(test)

if(MSVC)
  install(FILES
    ical.def
    icalss.def
    icalvcal.def
    DESTINATION
    ${LIB_INSTALL_DIR}
  )
endif()

=== src/libical/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/icalversion.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/icalversion.h @ONLY)
+configure_file(
+  ${CMAKE_CURRENT_SOURCE_DIR}/icalversion.h.cmake
+  ${CMAKE_CURRENT_BINARY_DIR}/icalversion.h
+  @ONLY
+)
 
 include_directories(
   ${CMAKE_BINARY_DIR}
@@ -11,8 +15,8 @@
 if(WIN32)
   if(MSVC)
     add_definitions(-DBUILD_LIBICALDLL)
-  endif(MSVC)
-endif(WIN32)
+  endif()
+endif()
 
 configure_file(icalerror.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/icalerror.h)
 
@@ -132,10 +136,10 @@
 if(WIN32)
   set(TOPS "\"${CMAKE_SOURCE_DIR}\"")
   set(TOPB "\"${CMAKE_BINARY_DIR}\"")
-else(WIN32)
+else()
   set(TOPS "${CMAKE_SOURCE_DIR}")
   set(TOPB "${CMAKE_BINARY_DIR}")
-endif(WIN32)
+endif()
 
 add_custom_command(
   OUTPUT
@@ -156,13 +160,6 @@
   ${CMAKE_BINARY_DIR}/src/libical/ical.h
 )
 
-macro(_list_prefix _outvar _listvar _prefix)
-  set(${_outvar})
-  foreach(_item IN LISTS ${_listvar})
-    list(APPEND ${_outvar} ${_prefix}${_item})
-  endforeach()
-endmacro(_list_prefix)
-
 # GObject Introspection
 if(HAVE_INTROSPECTION)
   include(GObjectIntrospectionMacros)
@@ -170,17 +167,20 @@
   #set(INTROSPECTION_SCANNER_ARGS "--add-include-path=${CMAKE_CURRENT_SOURCE_DIR}")
   #set(INTROSPECTION_COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}")
 
-  set(libical_0_48_gir "libical")
-  set(libical_0_48_gir_VERSION "0.48")
+  set(LIB_VERSION ${LIBICAL_LIB_VERSION_STRING})
+  string(REPLACE "." "_" LIB_VERSION "${LIB_VERSION}")
+  string(REPLACE "-" "_" LIB_VERSION "${LIB_VERSION}")
+
+  set(libical_${LIB_VERSION}_gir "libical")
+  set(libical_${LIB_VERSION}_gir_VERSION ${LIBICAL_LIB_VERSION_STRING})
   set(INTROSPECTION_SCANNER_ARGS ${CMAKE_BINARY_DIR}/src/libical/ical.h)
-  set(libical_0_48_gir_LIBRARY "ical")
-  set(libical_0_48_gir_INCLUDES GObject-2.0)
-  get_directory_property(_tmp_includes ical_LIB_SRCS)
-  _list_prefix(_includes _tmp_includes "-L")
-  set(libical_0_48_gir_CFLAGS ${_includes})
-  set(libical_0_48_gir_LIBS ical)
-
-  list(APPEND INTROSPECTION_GIRS libical-0.48.gir)
+  set(libical_${LIB_VERSION}_gir_LIBRARY "ical")
+  set(libical_${LIB_VERSION}_gir_INCLUDES GObject-2.0)
+  set(_includes ${_includes} "-L${LIBRARY_OUTPUT_PATH}")
+  set(libical_${LIB_VERSION}_gir_CFLAGS ${_includes})
+  set(libical_${LIB_VERSION}_gir_LIBS ical)
+
+  list(APPEND INTROSPECTION_GIRS libical-${LIBICAL_LIB_VERSION_STRING}.gir)
 
   gir_add_introspections(INTROSPECTION_GIRS)
 endif()
@@ -254,11 +254,13 @@
 if(WIN32)
   if(MSVC)
     list(APPEND ical_LIB_SRCS ../ical.def)
-  endif(MSVC)
-endif(WIN32)
+  endif()
+endif()
 
 add_library(ical ${LIBRARY_TYPE} ${ical_LIB_SRCS})
-add_library(ical-static STATIC ${ical_LIB_SRCS})
+if(NOT SHARED_ONLY)
+  add_library(ical-static STATIC ${ical_LIB_SRCS})
+endif()
 
 add_dependencies(ical ical-header)
 
@@ -266,22 +268,39 @@
 
 if(WINCE)
   target_link_libraries(ical ${WCECOMPAT_LIBRARIES})
-endif(WINCE)
+endif()
 
 if(MSVC)
   set_target_properties(ical PROPERTIES OUTPUT_NAME "libical")
-  set_target_properties(ical-static PROPERTIES OUTPUT_NAME "libical-static")
-else(MSVC)
-  set_target_properties(ical-static PROPERTIES OUTPUT_NAME "ical")
-endif(MSVC)
+  if(NOT SHARED_ONLY)
+    set_target_properties(ical-static PROPERTIES OUTPUT_NAME "libical-static")
+  endif()
+else()
+  if(NOT SHARED_ONLY)
+    set_target_properties(ical-static PROPERTIES OUTPUT_NAME "ical")
+  endif()
+endif()
 set_target_properties(ical PROPERTIES
   VERSION ${LIBICAL_LIB_VERSION_STRING}
   SOVERSION ${LIBICAL_LIB_MAJOR_VERSION}
 )
 set_target_properties(ical PROPERTIES CLEAN_DIRECT_OUTPUT 1)
-set_target_properties(ical-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
-
-install(TARGETS ical ical-static ${INSTALL_TARGETS_DEFAULT_ARGS})
+if(NOT SHARED_ONLY)
+  set_target_properties(ical-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
+endif()
+
+install(
+  TARGETS ical
+  EXPORT icalTargets
+  DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS}
+)
+if(NOT SHARED_ONLY)
+  install(
+    TARGETS ical-static
+    EXPORT icalTargets
+    DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS}
+  )
+endif()
 
 ########### install files ###############

=== src/libicalcap/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/libical)

########### next target ###############

set(client_SRCS client.c)

add_executable(client ${client_SRCS})

target_link_libraries(client)

########### install files ###############

install(FILES
  icalcap.h
  icalcap_impl.h
  icalcap_message_impl.h
  icalcap_server.h
  icalcap_server_impl.h
  icalcap_session.h
  icalcap_session_impl.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/libicalcap
)

=== src/libicalss/CMakeLists.txt ===
include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src/libicalss ${CMAKE_BINARY_DIR}/src/libicalss
  ${CMAKE_SOURCE_DIR}/src/libical ${CMAKE_BINARY_DIR}/src/libical
)

if(WIN32)
  set(TOPS "\"${CMAKE_SOURCE_DIR}\"")
  set(TOPB "\"${CMAKE_BINARY_DIR}\"")
else()
  set(TOPS "${CMAKE_SOURCE_DIR}")
  set(TOPB "${CMAKE_BINARY_DIR}")
endif()

add_custom_command(
  OUTPUT
  ${CMAKE_BINARY_DIR}/src/libicalss/icalss.h
  COMMAND
  ${CMAKE_COMMAND}
    -DTOPS:FILEPATH=${TOPS}
    -DTOPB:FILEPATH=${TOPB}
    -DICAL_FILE_H_FILE:FILEPATH=${CMAKE_BINARY_DIR}/src/libicalss/icalss.h
    -P ${CMAKE_CURRENT_SOURCE_DIR}/icalss_file.cmake
  DEPENDS
  ical-header
)

add_custom_target(icalss-header
  DEPENDS
  ical-header
  ${CMAKE_BINARY_DIR}/src/libicalss/icalss.h
)

########### next target ###############

#these are generated sources, but we keep them in the repo
set(icalss_LIB_DEVSRCS icalsslexer.c icalssyacc.c)

set(icalss_LIB_SRCS
  icalcalendar.c
  icalcalendar.h
  icalclassify.c
  icalclassify.h
  icalcluster.c
  icalcluster.h
  icalclusterimpl.h
  icalgauge.c
  icalgauge.h
  icalgaugeimpl.h
  icaldirset.c
  icaldirset.h
  icaldirsetimpl.h
  icalfileset.c
  icalfileset.h
  icalfilesetimpl.h
  icalset.c
  icalset.h
  icalssyacc.h
  icalspanlist.c
  icalspanlist.h
  icalmessage.c
  icalmessage.h
  ${icalss_LIB_DEVSRCS}
)

if(MSVC)
  list(APPEND icalss_LIB_SRCS ../icalss.def)
endif()

add_library(icalss ${LIBRARY_TYPE} ${icalss_LIB_SRCS})
if(NOT SHARED_ONLY)
  add_library(icalss-static STATIC ${icalss_LIB_SRCS})
endif()

add_dependencies(icalss icalss-header)
if(NOT SHARED_ONLY)
  add_dependencies(icalss-static icalss-header)
endif()

target_link_libraries(icalss ical)

if(MSVC)
  set_target_properties(icalss PROPERTIES OUTPUT_NAME "libicalss")
  if(NOT SHARED_ONLY)
    set_target_properties(icalss-static PROPERTIES OUTPUT_NAME "libicalss-static")
  endif()
else()
  if(NOT SHARED_ONLY)
    set_target_properties(icalss-static PROPERTIES OUTPUT_NAME "icalss")
  endif()
endif()
set_target_properties(icalss PROPERTIES
  VERSION ${LIBICAL_LIB_VERSION_STRING}
  SOVERSION ${LIBICAL_LIB_MAJOR_VERSION}
)
set_target_properties(icalss PROPERTIES CLEAN_DIRECT_OUTPUT 1)
if(NOT SHARED_ONLY)
  set_target_properties(icalss-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
endif()

install(
  TARGETS icalss
  EXPORT icalTargets
  DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS}
)
if(NOT SHARED_ONLY)
  install(
    TARGETS icalss-static
    EXPORT icalTargets
    DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS}
  )
endif()

########### install files ###############

install(FILES
  ${CMAKE_BINARY_DIR}/src/libicalss/icalss.h
  icalcalendar.h
  icalclassify.h
  icalcluster.h
  icaldirset.h
  icaldirsetimpl.h
  icalfileset.h
  icalfilesetimpl.h
  icalgauge.h
  icalgaugeimpl.h
  icalmessage.h
  icalset.h
  icalspanlist.h
  icalssyacc.h
  DESTINATION
  ${INCLUDE_INSTALL_DIR}/libical
)

=== src/libicalvcal/CMakeLists.txt ===
include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src/libicalss ${CMAKE_BINARY_DIR}/src/libicalss
  ${CMAKE_SOURCE_DIR}/src/libical ${CMAKE_BINARY_DIR}/src/libical
  ${CMAKE_SOURCE_DIR}/src/libicalvcal ${CMAKE_BINARY_DIR}/src/libicalvcal
)

#these are generated sources, but we keep them in the repo
set(icalvcal_LIB_DEVSRCS vcc.c)

########### next target ###############

set(icalvcal_LIB_SRCS
  icalvcal.h
  icalvcal.c
  port.h
  vcc.h
  vobject.h
  vobject.c
  vcaltmp.h
  vcaltmp.c
  ${icalvcal_LIB_DEVSRCS}
)

if(MSVC)
  list(APPEND icalvcal_LIB_SRCS ../icalvcal.def)
endif()

add_library(icalvcal ${LIBRARY_TYPE} ${icalvcal_LIB_SRCS})
if(NOT SHARED_ONLY)
  add_library(icalvcal-static STATIC ${icalvcal_LIB_SRCS})
endif()

add_dependencies(icalvcal ical-header)
if(NOT SHARED_ONLY)
  add_dependencies(icalvcal-static ical-header)
endif()

target_link_libraries(icalvcal ical)

if(MSVC)
  set_target_properties(icalvcal PROPERTIES OUTPUT_NAME "libicalvcal")
  if(NOT SHARED_ONLY)
    set_target_properties(icalvcal-static PROPERTIES OUTPUT_NAME "libicalvcal-static")
  endif()
else()
  if(NOT SHARED_ONLY)
    set_target_properties(icalvcal-static PROPERTIES OUTPUT_NAME "icalvcal")
  endif()
endif()
set_target_properties(icalvcal PROPERTIES
  VERSION ${LIBICAL_LIB_VERSION_STRING}
  SOVERSION ${LIBICAL_LIB_MAJOR_VERSION}
)
set_target_properties(icalvcal PROPERTIES CLEAN_DIRECT_OUTPUT 1)
if(NOT SHARED_ONLY)
  set_target_properties(icalvcal-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
endif()

install(
  TARGETS icalvcal
  EXPORT icalTargets
  DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS}
)
if(NOT SHARED_ONLY)
  install(
    TARGETS icalvcal-static
    EXPORT icalTargets
    DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS}
  )
endif()

########### install files ###############

install(FILES
  icalvcal.h port.h vcc.h vobject.h vcaltmp.h
  DESTINATION
  ${INCLUDE_INSTALL_DIR}/libical
)

=== debian/changelog ===
libical (1.0.1-0ubuntu2) xenial; urgency=medium

  * Multiarchify the library packages.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jan 2016 15:32:14 +0100

libical (1.0.1-0ubuntu1) wily; urgency=medium

  * New upstream release
  * debian/docs:
  * debian/libical1a.docs:
    - Update for new docs
  * debian/libical1a.symbols:
    - Updated
  * debian/patches/reproducible-generator.patch:
    - Applied upstream

 -- Robert Ancell <robert.ancell@canonical.com>  Wed, 17 Jun 2015 12:08:36 +1200

libical (1.0-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libical1 to libical1a because the change introduced in the previous
    upload breaks compatibility. (Closes: #774242)

 -- Ivo De Decker <ivodd@debian.org>  Sat, 03 Jan 2015 14:58:46 +0100

libical (1.0-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Sort keys to generate reproducible source code. (Closes: #773916)

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Mon, 29 Dec 2014 18:42:22 +0000

libical (1.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add missing license information to debian/copyright.
    (Closes: #738967)

 -- Tobias Hansen <thansen@debian.org>  Sun, 19 Oct 2014 00:28:41 +0200

libical (1.0-1) unstable; urgency=medium

  * New upstream release (Closes: #717417)
  * Remove patches - merged upstream:
    - 0001_convert_float_to_strings_with_snprintf_sfbug3493034.patch
    - fix_arm_ftbfs.patch
    - fix_ftbfs_dependencies.patch
  * Update debian/control:
    - bump soname (libical0 -> libical1)
    - bump Standards-Version to 3.9.5 (no changes needed)

 -- Fathi Boudra <fabo@debian.org>  Sun, 09 Feb 2014 12:05:44 +0200

=== debian/control ===
Source: libical
Section: libs
Priority: optional
Maintainer: Fathi Boudra <fabo@debian.org>
Build-Depends: cmake, debhelper (>= 9), tzdata
Standards-Version: 3.9.5
Homepage: http://freeassociation.sourceforge.net

Package: libical-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libical1a (= ${binary:Version}), ${misc:Depends}
Description: iCalendar library implementation in C (development)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.

Package: libical1a
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: tzdata, ${misc:Depends}, ${shlibs:Depends}
Breaks: libical1
Replaces: libical1
Description: iCalendar library implementation in C (runtime)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.
 .
 This package contains the files necessary for running applications that use
 the libical library.

Package: libical-dbg
Priority: extra
Architecture: any
Multi-Arch: same
Section: debug
Depends: libical1a (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for libical
 This package contains the debugging symbols associated with libical.
 .
 They will automatically be used by gdb for debugging libical related issues.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake --parallel --list-missing --dbg-package=libical-dbg

override_dh_install:
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/lib* debian/tmp/usr/lib/pkgconfig \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install
